import { _ as _defineProperty, I as ImmerChangeset } from '../immer-changeset-a09b1f1e.js';
import { buildTask } from 'ember-concurrency/-private/async-arrow-runtime';
import Component from '@glimmer/component';
import { assert } from '@ember/debug';
import 'ember-concurrency';
import { isChangeset } from '../utils/is-changeset.js';
import { precompileTemplate } from '@ember/template-compilation';
import { setComponentTemplate } from '@ember/component';

var TEMPLATE = precompileTemplate("<form {{on \"submit\" (perform this.submit)}} ...attributes>\n    {{yield this.validateAndSubmit}}\n</form>");

class ChangesetFormComponent extends Component {
  constructor(owner, args) {
    super(owner, args);
    _defineProperty(this, "validateAndSubmit", buildTask(() => ({
      context: this,
      generator: function* () {
        yield this.args.changeset.validate(this.args.validationFunction);
        if (this.args.changeset.isValid) {
          yield this.args.onSubmit(this.args.changeset);
        }
      }
    }), {
      drop: true
    }, "validateAndSubmit", null));
    _defineProperty(this, "submit", buildTask(() => ({
      context: this,
      generator: function* (e) {
        e.preventDefault();
        yield this.validateAndSubmit.perform();
      }
    }), null, "submit", null));
    assert('@changeset is required and must be an ImmerChangeset', isChangeset(args.changeset) && args.changeset instanceof ImmerChangeset);
    assert('@onSubmit is required', typeof args.onSubmit === 'function');
    assert('@validationFunction is required', typeof args.validationFunction === 'function');
  }
}
setComponentTemplate(TEMPLATE, ChangesetFormComponent);

export { ChangesetFormComponent as default };
//# sourceMappingURL=immer-form.js.map
